Welcome!

Total Software Deployment (TSD) is a software product developed by Softinventive Lab Inc. Its main function is remote software deployment for local networks.

Network scanning

  • Scanning Windows assets
    • Remote scanning via SMB
    • Manual scanning
 Working with TSD
  • Workspace
  • Network scanning
  • Different methods of creating a deployment package
Software deployment
  • How to create deployment packages in TSD:
    • Using Silent
    • Using Macro
    • Using Sysshot
  • Deployment to remote Windows systems


White paper

List of terms

TSD: stands for Total Software Deployment and represents its name and trademark.

Admin unit (main unit): a GUI application operated by the user. It's installed on a workstation or a server computer and is used for computer scanning, as well as for viewing and deploying software.

Scanning: a process of collecting hardware and software information from a computer or a device.

Deployment: a process of installing software on a computer.

Network storage: a database of scanned network computers.

Software storage: a database of software for deployment.

Minimum system requirements for the admin unit

CPU | 1000 MHz
RAM | 512 MB
HDD space | 30 MB + 0,35 MB per stored asset + additional space for software installers
Network | TCP/IP
OS | Windows XP or higher
Screen | 1280x1024

Database mechanism

TSD works with 2 independent databases (also known as Storages): the software storage and the network storage. A Storage is a user-created folder on the hard drive.

In the Network storage, each scanned asset is represented by a separate file. Auxiliary data is stored separately from the asset files and includes user information, logins and passwords for remote access, etc. All data is encrypted.

In the Software storage, each program is represented by a separate folder containing the program installer, the Deployment package(s) and the deployment history. Auxiliary data is stored separately.

It's possible to create several separate storages and switch between them at any time. Asset-related data can be copied to another storage by copying the corresponding file.

Topics:

  • Scanning Microsoft Windows assets
  • Creating a software installation package for deployment
  • Software deployment to remote Microsoft Windows systems


Scanning Microsoft Windows assets

Technology

Total Software Deployment borrows its scanning technology from Total Network Inventory 3. However, unlike TNI 3, TSD only provides information from the Software category. This information can be used to help make a decision about software deployment on a remote computer. All other information is collected to guarantee usage of the Network storage across multiple software. You can setup your TSD and TNI 3 to use the same Network storage. Then you will only need to scan the network in one of the programs, but the Storage will stay up-to-date in both.

Windows Management Instrumentation (WMI) is Microsoft's implementation of Web-Based Enterprise Management (WBEM) standard for Windows operating systems.

Using WMI technology, TSD obtains software information, as well as computer registry data.

WMI service is pre-installed on Windows 2000 and higher. For Windows NT, Windows 95 and Windows 98 it is available for download from the Microsoft website.

There are three methods for scanning Windows-based computers that are used in Total Network Inventory, however TSD does not use remote scanning via the RPC protocol.

Manual scanning is the only way to collect information from computers running Windows XP Home Edition. This OS cannot be accessed remotely due to its limitations. Any connection attempt will result in the Access denied error.

Remote scanning via the SMB protocol

How it works:

  1. Executable tniwinagent.exe (an agent) is uploaded to the administrator's shared folder admin$ on a remote computer.
  2. TSD's main unit connects to the Service manager on the target PC, installs the agent as a service and starts it.
  3. The agent collects the information and saves it into a compressed file. Then it stops.
  4. The main unit imports the resulting file into the Storage.
  5. The agent service is uninstalled, and the executable is deleted.

No traces of scanning will remain on the target PC after the scan is complete.

Requirements for the target machine:

CPU | 500 MHz
RAM | 64 MB
HDD space | 0.5 MB
TCP ports | 139, 445
Services | Server Windows Management Instrumentation (WMI) Remote Procedure Call (RPC) Remote Registry
Resources | ipc$ admin$
Protocols | SMB NetBIOS (for Windows NT4) TCP/IP
Windows version | NT4 / 2000 / XP Pro / Vista / 7 / 8 / 2000 Server / Server 2003, 2008, 2008 R2, 2012, 2012 R2

Manual scanning

How it works:

  1. Executable tniwinagent.exe (an agent) is copied to the target PC manually and run. Upon completion of its work, the agent creates a file containing the collected data.
  2. The created file is manually moved to the TSD Network storage.

Additionally:

The agent can be run by a domain logon script, by the task scheduler or on Windows startup.

Command line parameters of the agent tniwinagent.exe:

  • /path:"\\server\share" allows to set a path to a folder where the data file will be placed;
  • /delay:XX specifies the gap in seconds between the agent's launch time and the start of the scan;
  • /overwrite overwrites the data file in case the target folder already contains its older version (otherwise, new files appended with (2), (3), etc. will be created after each scan).

Requirements for the target machine:

CPU | 500 MHz
RAM | 64 MB
HDD space | 0.5 MB
Services | Windows Management Instrumentation (WMI)
Windows version | NT4 / 2000 / XP / Vista / 2000 Server / 2003 Server / 2008 Server / 7 / 8 / 2012 Server / 10

Scanning overhead

All scanning methods require CPU time and execution of a variety of disk operations, which is why an insignificant loss of efficiency may occur while scanning a computer. Scanning usually takes 1-2 minutes.

Network traffic generated (on demand):

Method | To remote computer (upload) | From remote computer (download)
SMB | 0.31 MB | 0.06 MB

Numbers in the table represent average values including service data size (i.e. packet headers, etc.).

Collected information

Operating system

  • Name, version, architecture, registered user, install date, country code, locale;
  • OS type, product key, suite, SKU, supply channel;
  • Internet Explorer version, DirectX version;
  • Etc.

Installed software

  • Name, publisher, version, install date and source, uninstall string;
  • For Microsoft Office: service pack, product ID, product key, supply channel.


Creating a software installation package for deployment

Technology

Total Software Deployment offers 3 methods for creation of deployment packages. None of them interferes with the remote user's work. Each method has its advantages and disadvantages.

Silent

The best solution for installers that support the silent installation mode. It’s not necessary to install the remotely deployed program on the local computer. This method uses installer parameters to set up a silent installation.

How it works:

  1. The main module automatically determines the type of the installer and inserts a package of parameters essential for silent installation into the command line. User can select additional parameters, edit them or enter manually. If TSD cannot determine the type of the installer, user may select the type from the list of installers or enter the silent installation parameters in the corresponding field manually.
  2. The program is ready for deployment, though we recommend to check the parameters using the Test run (local) button. If the installer window is awaiting user input, then one of the parameters is not compatible with the installer.

Advantages:

  1. Easy to record.
  2. Reliable deployment of software to a remote computer if all the parameters are valid.

Disadvantages:

  1. The installer must be compatible with the parameters. Besides, if TSD fails to determine the type of the installer, user must input parameters manually.

You can't be sure the program will be deployed successfully unless you do a test run.

Macro

A good fit for most software with the standard installation wizard. The program to be deployed remotely must be first installed locally. This method is based on recording user actions during the installation for future playback on a remote computer.

How it works:

  1. You need to make sure the program hasn't already been installed locally (as well as remotely), as the installer wizard may contain a different set of steps.
  2. TSD’s recording module activates the RHookLib.dll library to run with any launched processes, except for the ones on the ignore list (by default this list includes processes already running the moment the recording starts). Then the recording module runs the installer's executable file.
  3. User installs the program on the local computer. Meanwhile the library intercepts all of the user's actions and records them to Install.jhr located in the temporary folder of the OS.
  4. It is not recommended to set the install location using the Browse button, as the interface of the browse window on a remote computer may differ from yours. As a result, the macro playback won't find the necessary window and will be waiting until timeout. To prevent such behavior, use Safely select destination folder (the yellow folder button) in the Macro recording window. Alternatively, you can insert the installation path directly with Paste from clipboard and Paste text into the installer’s focused control.
  5. Upon completion of the installation the RHookLib.dll library is unloaded from the processes and the recording module moves the Install.jhr file into the corresponding folder of the Software storage.

Advantages:

  1. Easy to record.
  2. Visualization of the recorded method for editing.

Disadvantages:

  1. Not compatible with all installers. Software publishers can develop and use their own installer, which can be based on custom controls that imitate the look and behavior of some standard controls. The Macro method won't recognize the changes in these controls.
  2. Sometimes conflicts may occur when deploying to an OS with a different Windows theme. This happens due to some differences in position and size of window controls between different Windows themes. Thus a mouse cursor may position outside the control region.

This method has no major advantages over the Silent installation method. It is recommended for use only when Silent installation is unavailable.

Sysshot

This method is suitable for small programs or tools. The program to be deployed remotely must be first installed locally. By analyzing two system shots (before and after the installation) TSD determines the differences between them and saves them for future deployment.

How it works:

  1. You need to make sure the program isn't installed locally before recording; otherwise, the difference between the two system snapshots won't include all necessary data.
  2. TSD’s recording module makes the first system snapshot and starts file system monitoring in system folders (and any user-defined). Then TSD runs the installer.
  3. User installs the program on the local computer. Meanwhile the recording module detects and saves all the file changes in the defined folders.
  4. After the installation the recording module stops file system monitoring and makes the second system snapshot. Then TSD compares these two snapshots and saves the differences between them.

Advantages:

  1. Compatible with any type of installer.
  2. Easy to record (one click).

Disadvantages:

  1. Generates a large deployment data file. Its size may be larger than the size of the installer and affects drive space requirement for the Software storage.
  2. This method scans the registry and the file system for all changes in specific locations. That includes changes made by background services or applications and the operating system itself, which results in unnecessary data in the deployment file. It is possible to edit the snapshot differences after recording to exclude this unnecessary data.
  3. Sometimes, if the target system architecture is different from the architecture of the system where the deployment package was created, conflicts may appear. This occurs due to some differences in the registry structure between x64 and x86 architectures.

You are strongly discouraged from using this method for deployment of drivers, codecs, system utilities and libraries.


Software deployment to remote Microsoft Windows systems

Software deployment via the SMB protocol

How it works:

  1. The following files are uploaded to the administrator share admin$ on the remote computer: the Tsdservice.exe executable (the agent), Script.scr (deployment settings), TweakInstaller.32.dll and TweakInstaller.64.dll (used for making screenshots during the Macro playback), the deployment package file (its filename depends on the software ID in the Storage and on the recording method) and program's installer (if needed).
  2. TSD's main unit connects to the Service manager on a target PC, installs an agent and runs it as a service.
  3. The agent creates a custom hidden desktop, where the installation process will be performed.
  4. The agent loads the file containing deployment settings, launches installations, then waits for their completion and stops.
  5. TSD's main unit imports log files into the deployment history.
  6. The agent service is uninstalled, and all deployment files are deleted.

No traces of deployment will remain on the target PC after the deployment is complete.

Requirements for the target machine:

CPU | As recommended for the installed OS
RAM | As recommended for the installed OS
HDD space (macro and silent install) | ~2.5 MB + (program installer size + program's space requirements) * number of programs to deploy
HDD space (sysshot) | ~2.5 MB + (deployment package file size, which is about twice the size of the installer + program's space requirements) * number of programs to deploy
TCP ports | 139, 445
Services | Server Remote Procedure Call (RPC) Remote Registry
Resources | ips$ admin$
Protocols | SMB TCP/IP
Windows version | XP Pro / Vista / 7 / 8 / 8.1 / Server 2003, 2008, 2008 R2, 2012, 2012 R2


FAQ

General questions

Installation

Q: Should I install the program on a server or on a workstation?

A: Both a server and a workstation can run Total Software Deployment. It’s just a matter of usage convenience, because it's not a client-server application, and you need to have access to the graphical console of the computer it's installed on, either directly or by using a remote desktop utility. However, if you run it under the domain admin account, you’ll be able to scan all computers, and also deploy to them, as "current user" - otherwise you’d need to specify domain admin credentials explicitly.

However, take note that if you install the program on Windows XP SP2/SP3 or Vista SP0/SP1 and there are a lot of scan threads launching simultaneously, there may be issues with connections to remote computers. This is caused by a restriction on the maximum number of TCP half-open connections (connection attempts, SYN_SENT socket state) existing in the aforementioned Windows versions, which doesn't allow for more than 10 outbound connections to be in this state at a time. After reaching this limit, all other connections in the system (including those executed by this program) are queued and may reach their timeout, thus producing inconsistent results. This issue is also known as the “Event 4226” issue, because reaching the limitation produces a record in the System Event Log with EventID 4226. Windows 2000, Windows XP SP0/SP1, Windows Vista SP2, Windows 7/8, and all Windows Server systems don't have such a limitation. Thus, in the general case, we recommend to install the program on server systems or modern desktop systems.

Backup and restore

Q: How to backup/restore the Storages or move the program to another computer?

A: The Storages are located in separate folders (file system directories). The Network storage can be located by right-clicking the Storage root group and selecting Show in Explorer. Then go up one level and copy/archive the whole storage folder.
The Software storage can be located by right-clicking any software in the Storage and selecting Show in Explorer. Then go up two levels and copy/archive the whole Storage folder.

Program settings can be backed up by copying/archiving a folder entitled Total Software Deployment in your account's Application Data folder (referred to by %APPDATA% environment variable), if you chose Install for me during the program installation. If you chose Install for all, the settings are stored in "C:\Documents and Settings\All Users\Application Data\Total Software Deployment" (Windows 2000/XP/2003) or "C:\ProgramData\Total Software Deployment" (Windows Vista/7/8/10/2008/2012). You can also find this folder by clicking Open tasks folder in the Scanner tab.

To restore the program, install it on another computer (but don't run it) and extract your backed-up settings to the Total Software Deployment folder in the Application Data folder for your profile or all users, depending on your choice during the installation (after the installation, this folder is automatically created and contains one file: config.ini). Also, extract the Storage folder locally: for instance, to My Documents. Then run the program and browse to the Storage folder when prompted (if its location differs from the path stored in previous settings).

Network storage

Q: Is it possible to use the same Network storage in both TSD and TNI 3?

A: Yes, it is. The Network storage is fully compatible with the TNI 3 storage. It's also possible to use the same network storage in TSD and TNI 3 at the same time, as both programs will detect storage changes and update information. However, TSD will only display and allow to modify Windows nodes.

Q: Is it possible to look up which software versions are installed on computers in the Network storage?

A: Yes, it's possible. Please use the Assistant. Detailed information on how to use the Assistant can be found in this section.

Software storage

Q: What should I do if the installer consists of more than one file?

A: Please see the following section: Software tree - Altering the Software storage structure - Adding software.

Selecting a method for recording & deployment

Silent installation

Q: When should I use the silent installation method?

A: Most modern installation packages support the silent installation mode. In this mode programs install without user interaction: all processes perform automatically.
This mode is enabled (in most cases) by adding parameters to the command line of the executable. Setting a few parameters may be required to achieve the desired result.
Silent Installation is the most preferable method to use.

Q: In which cases is it not possible to use the silent installation method to create deployment packages?

A: Most modern installation packages support the silent installation mode, yet there are exceptions:
Online downloaders may have parameters that allow the downloader to operate without user intervention, but at the same time the downloadable installation package is either run without any options or the downloader’s parameters are not compatible with it.
Self-extracting archives may have parameters that allow the downloader to extract the contents without user intervention, but at the same time they may not be designed to make the installation package run with the required parameters.
Installation packages in which the silent installation is not available, either intentionally disabled during the creation of the package.

Q: Could TSD incorrectly determine the type of the installer, and, when TSD does determine the type correctly, could the silent installation keys still fail to be compatible (installation requiring user interaction)?

A: Yes, it is possible. In order to verify that the type of the installer has been determined correctly, you must use the "Test run (local)" option. If the installer requires user interaction to install a program, then the specified parameter package is not compatible with the installer.

Q: What should I do if TSD could not determine the type of the installer automatically, but I know either the type of the installer or which parameter to use for the silent installation?

A: In the former case, you can manually select the type of the installer from the list, and then TSD will provide the necessary parameters for the silent installation. In the latter case, input the silent installation parameters manually. In any case, we recommend you use "Test run (local)" to ensure successful deployment.

Q: Can I create a deployment package if my installer installs silently without any parameters?

A: Yes, you can. In this case, you should use the "Use empty command line" option. Then TSD will not add any parameters to the command line of the executable when deploying remotely.

Q: What should I do if I selected the type of the installer manually, and now I cannot recall what type was initially determined by TSD?

A: You can use the “Redetermine the installer type” button, then “Set default command line for the silent install”. The program will redetermine the installer type and offer you a minimal parameter string for silent installation.

Q: Why do you recommend not to execute the installation package from a batch file?

A: It's not prohibited, but because of the difficulties in tracking the execution status of such a package, the information about the deployment process will often be wrong, and we cannot guarantee that this package will be deployed successfully.

Q: What should I do if I need to execute a few CMD commands before and after the installer?

A: Create a new deployment package with a batch file, add the installer and, if necessary, another batch file as Add-ons. For more information, see Add-ons.

Q: What should I do if I need to execute a few CMD commands before and after the installer, but the installer is multi-file?

A: Create two deployment packages: one with a batch file, the other with the multi-file installer. If necessary, add a batch file to the 2nd package as an Add-on. Before deployment, add the 2 packages to the Software deployment list in the correct order in which they should be executed on the remote computer. For more information, see Add-ons.

Q: What should I do if I can’t use the silent installation method to create a deployment package?

A: Try using other methods offered by TSD (Macro, Sysshot).

Macro

Q: When should I use the macro method?

A: This method is suitable for most software with a standard installation wizard.

Q: In which cases is it not possible to use the macro installation method?

A: Software vendors may develop their own installer, also using their own controls, which can imitate the look and behavior of a number of standard controls. The macro will not recognize the changes in such controls. Also, ads may be displayed in the installer. They may change over time and cause problems during deployment. TSD keeps track of user's interaction with such control elements and displays the following error message: "During the macro recording you have interacted with nonstandard control(s) which are not compatible with the macro method". In such a case, remote deployment will be impossible.

Q: What should I do if after using the macro method TSD displays a message that interaction with non-standard control elements has occurred?

A: Try to create the deployment package again without interacting with such controls. If it’s not possible, try another method.

Q: When do I have to select the macro method?

A: This method has no significant advantages over the silent installation method and is only recommended for use when, for whatever reason, silent installation is impossible.

Q: What should I do if I can’t use the macro method to create a deployment package?

A: You can always try using other methods offered by TSD.

Sysshot

Q: When can I use the sysshot method?

A: This method is suitable for small software. We recommend using this method only if you’re an advanced user and when the other two methods cannot be used.

Q: In which cases is it not possible to use the sysshot method?

A: You are strongly discouraged from using this method for deployment of drivers, codecs, system utilities and libraries.

Q: Is it possible that a package recorded using sysshot and deployed remotely will not work?

A: Yes, it’s possible. Sometimes, if the target system architecture is different from the architecture of the system where the deployment package was created, conflicts may appear. This occurs due to some differences in the registry structure between x64 and x86 architectures.

Scan questions

Access is denied

Q: How do I deal with the errors "Access is denied" or "Unknown user name or bad password"?

A: These errors can occur for several reasons:

  • Username or password are specified incorrectly.

Check your username and password.

  • The specified user account does not have administrator rights on the remote machine.

You need to have administrator access to remote computers to be able to scan them (local administrator or domain administrator rights). If you have logged on as domain administrator or remote computers have the same name and password for the local administrator account as your account, you can use the Current user scan option. Otherwise specify the user name in full format: DOMAIN\Administrator.

  • Blank password.

Remote administrator access with blank password is not allowed starting with Windows XP.

  • The scanned computer has Windows XP Home Edition installed.

This version of Windows cannot be scanned remotely. It’s an OS limitation, and the Access denied error will be displayed at all times. However, it’s possible to scan XP Home locally by running the standalone audit tool tniwinagent.exe (located in the program's installation folder) on that machine. It’ll generate an .inv file with scan results, which should be copied to the program's Storage (it will be imported upon TSD’s next launch or immediately, if TSD is running) or imported by using the Storage main menu or any group's context menu.

  • Computers are not in the domain and have default settings.

Workstations running Windows XP, Vista or later client versions and not connected to a domain don't allow the local administrator to authenticate as himself by default. Instead, the ForceGuest policy is used, which means that all remote connections are mapped to the Guest account. But again, the administrator rights are required for running the scan. Thus, you need to update the security policy on each computer using one of the following ways:

* Run secpol.msc, expand Local policies / Security options, locate the Network access: Sharing and security model for local accounts policy and change its value from Guest to Classic.
* Disable the Use simple file sharing option in File Explorer’s Folder Options.
* Modify the registry: set the forceguest value, located in the "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Lsa" key, to zero.

For Windows client versions starting with Vista, an additional step should be taken: it concerns the User Account Control (UAC). It restricts administrator rights for remote logons in certain cases. You should either disable UAC or make changes to the registry: create a DWORD parameter (name: LocalAccountTokenFilterPolicy; value: 1) in the "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\system" key ( source ). A reboot may be required.

You can modify both settings easily by running a .reg file with the following contents on such computers (omit the last two lines for Windows XP):

Windows Registry Editor Version 5.00
[HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Lsa]
"forceguest"=dword:00000000
[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\system]
"LocalAccountTokenFilterPolicy"=dword:00000001

Port numbers

Q: How can I find which port numbers are used by TSD, so that I can configure the firewall?

A: TSD uses the SMB protocol to scan Windows computers. It can be allowed by enabling the File and Printer Sharing exception in the Windows Firewall or TCP port 445 in other firewalls. You could also enable TCP port 139 (NetBIOS) for older systems.

TCP/IP security limit

Q: How do I deal with the following warning: "TCP/IP has reached the security limit imposed on the number of concurrent TCP connect attempts"?

A: This warning may appear when you run the network scan under Windows XP SP2/SP3 or Windows Vista SP0/SP1 with port scan enabled. In these operating systems a controversial limitation of not more than 10 concurrent TCP connect attempts ("half-open connections") has been introduced by Microsoft to reduce the speed with which malicious software spreads over the networks. You can find more information in this Microsoft article. When you see this message in the scanner log, it means that the program detects that some computers have no open ports and there is an event with ID 4226 (source: Tcpip) in the system Event Log with the same message. As a consequence of reaching the aforementioned limitation, the program cannot reliably detect whether ports on computers are open or not. That's why the program starts to ignore the port scan results and connects to all computers using all selected protocols to provide successful scans. This policy remains active during the current session, that is, until the next program restart. To avoid this warning you can do the following:

  • Disable the Scan ports option in the Scanner settings. Note that this will decrease the network scan performance.
  • Patch your system using the widely known patch by LvlLord or this patch (based on the former). However, note that this is illegal according to the Windows EULA.
  • Run TNI on the system which is not affected by this limitation: Windows Server 2000/2003/2008, Windows 2000, Vista SP2 or Windows 7.

No network provider accepted the given network path

Q: How to fix the following error: "No network provider accepted the given network path"?

A: Take the following steps:

  1. Make sure that you can ping the remote computer by network name.
  2. Make sure that the File and Printer Sharing exception is enabled in the Windows Firewall (or that NetBIOS is allowed in any other firewall), or the firewall is disabled.
  3. Make sure that both Client for Microsoft Networks and File and Printer Sharing For Microsoft Networks are enabled in the properties of the network connection on the remote computer.
  4. Make sure that the NetBIOS over TCP/IP setting in the properties of the network connection (Internet Protocol Version 4 - Properties - Advanced - WINS) is set to Default or Enabled and that the TCP/IP NetBIOS Helper service is set to Automatic and started.
  5. Make sure that the Network security: LAN Manager authentication level security policy (secpol.msc - Local Policies - Security Options) is set to Send LM & NTLM responses (option #1) or Send LM & NTLM responses - use NTLMv2 session security if negotiated (option #2).
  6. Run sfc /scannow.

Call was canceled by the message filter

Q: How can I fix the "Call was canceled by the message filter" error?

A: Take the following steps:

  1. Run services.msc on the remote computer and make sure that the Windows Management Instrumentation service is set to Automatic and started.
  2. Make sure that DCOM is enabled: run dcomcnfg, select Component Services - Computers - My Computer, right-click, choose Properties, open the Default Properties tab and make sure that Enable Distributed COM on this computer is on.
  3. Restart the remote computer.
  4. Run the WMI diagnosis utility from Microsoft.
  5. Follow these tips to repair WMI on the remote computer.

Deployment questions

Errors when adding deployment tasks

Q: How can I resolve the error: "application has no bitness specified"?

A: This message will appear if software bitness has not been set when creating a software deployment package. Go to the Software editor and set bitness in the passport. More information about bitness can be found in the Program bitness section.

Q: How can I resolve the error: "The [silent|macro|sysshot] file is of unknown version"?

A: This error occurs when a package created in a newer version of TSD is being deployed using an old version. To solve the problem, update to the latest version of TSD. On the other hand, new versions of TSD support older version packages.

Q: How can I resolve the error: "The recorded macro file contains interactions with controls not compatible with the macro"?

A: The error is caused by user interaction with a control incompatible with the Macro method. You can see the incompatible control in the Macro editor: it will be highlighted on the screenshot. If it's possible, try re-recording the method without using this control; if the error doesn't disappear, then it's most likely that this installer is not supported by the Macro method. Try using other deployment methods: Silent or Sysshot.

Q: How can I resolve the error: "Some parameters string(s) in the silent method have not been filled"?

A: The error occurs when a Silent package is added to the Software deployment list, and one or several parameter strings are not set. Open this package in the Software editor and make sure the parameter fields are filled in for the software and any add-ons. Tick Use empty command line for each software or add-on which do not require any parameters.

Q: How can I resolve the error: "this asset has neither a network name nor an IP address specified" or "this asset has no IP address specified"?

A: One of the nodes moved to the Deployment targets list has no IP address set. In Options, set the Handling of dynamic IP addresses setting to option #1 or #2, then ping the computer and make sure it's the correct deployment target.

Deployment errors

Q: I use TNI 3 storage, and when trying to deploy to one of my scanned nodes, I get the following error: "Remote service manager error: Access is denied". What's the problem?

A: This problem may occur if you're using Active Directory. TNI 3 uses 2 protocols to scan the network: SMB and RPC. SMB is the principal method of scanning. However, if an access error occurs, TNI will scan using the backup option that is RPC, for which having domain user privileges will be sufficient. Deploying software using the RPC protocol is impossible, therefore RPC scanning is disabled. The same SMB protocol is used for deployment, but domain administrator privileges are required.

Q: How can I resolve the error: "For correct deployment, the target user must be logged in on the remote computer and his session must be active"?

A: This error occurs because environment of the user for which they are installed is necessary for normal installation. If you run the installer as another user or as System, there may be issues during software installation: shortcuts missing from the desktop, failure to start (for another user) or installer errors during deployment (when run as System). Therefore, the installer should be run as current user when deploying Silent or Macro packages to remote computers.

Q: How can I resolve the error: "Creating remote service error: The specified service has been marked for deletion" or "Creating remote service error: Overlapped I/O operation is in progress"?

The main causes of such issues:

  • Opened Process Explorer (SysInternals);
  • Opened Task Manager;
  • Opened MMC;
  • Opened Event Viewer;
  • An instance of Visual Studio using the debugging service.

If you cannot accurately determine the cause, we advise to restart the target node and repeat the deployment.

Q: How can I resolve the error: "While copying file an error has occurred"?

A: This error occurs because the installer process was not shut down when this software was last deployed to the same computer, and presently TSD cannot copy the installer to the temporary directory on the remote computer because the installer file left from the previous deployment is busy. We recommend either rebooting or remotely connecting to the computer in order to kill the installer process.

Q: How can I resolve the error: "Silent installation was terminated due to timeout. The command line parameters or the timeout value may be inappropriate"?

A: This error occurs when the deployment of the software did not complete within the allotted timeout. Here are the possible causes and how to deal with them:

  • The command line parameters used are unsuitable for silent installation in this case. To make sure the parameters are correct, first perform a Test run (locally).
  • The target computer is low-power and/or under heavy load, which slows the software deployment, and the specified timeout is not enough to complete the deployment. To solve this problem, when setting a timeout, consider the possible scenarios that could affect deployment on the target computer.
  • External factors on the target computer – such as no Internet connection or absence of a system package (VC++ Redistributable, .NET Framework, etc) – will impede deployment even when the parameters are correct. To resolve this issue, contact tech support for the software and find out what packages are required for installation.

More about waiting for the installation process to complete: in the Timeout section here.

Q: What can I do if TSD reports that software deployment using the Silent method has completed successfully, but in reality the software was not installed on the target computer?

A: TSD monitors installation progress, however such a scenario could happen if the installer process finished correctly, but has not in fact installed anything. Possible causes of this include loss of Internet connection, absence of a system package (VC++ Redistributable, .NET Framework, etc) and an error in command line parameters. To resolve the problem, perform a Test run (locally) from the Software editor, and then, if the problem is still not evident, try running the installer manually on a remote computer both without CMD parameters and with parameters set in TSD, and see if there's a difference.

Q: How can I resolve the error: "The configuration.xml file was not found. Please check file existence"?

A: This error can occur when deploying MS Office to a remote node, but the configuration file is missing from the Software storage. To resolve the problem, edit the Office package (the file will be automatically created once the editor is opened), modify the configuration file if necessary and repeat deployment.

Q: Why didn't my Macro package deploy to the remote computer? It was recorded correctly!

A: This scenario is possible if the program you're trying to deploy is already installed there, and the installer may be offering you to uninstall the program instead. Also, in another environment, the installer may have a different set of steps. Thus, certain steps in which actions were recorded may be missing during playback, or new unrecorded steps may appear.

Q: What can I do if a package was recorded correctly using the Macro method, but the following error occurs: "Cannot find the installer window. You can take a look at the last screenshot of the installer window"?

A: Deployment history will in most cases contain a link to a screenshot of the installer screen when the macro ceased playback (Deployment log will also contain the link.) The same entry will also contain a Software editor link to the action that stopped the playback. If the package is rerecorded, those links will become obsolete and be deleted. To accurately determine the reason why the necessary screen cannot be found during playback, compare the screenshot taken during the deployment with the one taken during the recording.

Q: How can I resolve the error: "Installer process(es) terminated due to timeout."?

A: This error will occur during deployment using the Macro method if the macro playback is over, but the installer process remains running until the 10 minute timeout has elapsed. Such a scenario will most often occur if the macro was recorded on a computer where the same program is already installed or if installer processes are monitored incorrectly according to its settings. For more information about waiting for installer child processes, see Monitoring installer processes in the Macro section.

Q: How can I resolve the error: "Cannot find the installer window. The installer process on the remote computer no longer exists, therefore, it's not possible to obtain a screenshot of the installer's last screen"?

A: This error will occur during deployment using the Macro method if the installer has closed before playing back all the recorded actions. To resolve this problem, make sure that the software is compatible with the target operating system and that the same steps are needed to install the software on the target machine as on the one where the package was recorded.

Q: How can I resolve the error: "Services are non-interactive on the remote computer; therefore, deployment of MSI files using the Macro method is impossible"?

A: Microsoft Installers have a client-server structure. MSI Installer Client is responsible for the user interface and for collecting information through user interaction and Server is directly responsible for installation. When services are non-interactive during remote installation, MSI Client considers itself incapable of drawing the interface and closes immediately, and therefore the TSD service won't find the expected installer window to interact with. In order to deploy MSI files, use the Silent method or enable interactive services on the remote computer.

In order to make services interactive, do the following:

  • Open regedit on the remote computer and navigate to HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Windows;
  • Change the NoInteractiveServices registry key to 0.

Q: What can I do if the following warning appeared during deployment: "TSD Service is already running. Abort?"?

A: One possible cause for this warning is the TSD service which may still be running on the target computer following previous deployment because the installer process itself is still running. In order to continue with the current deployment, the hung TSD service has to be stopped. Another cause could be current software deployment to the same computer using another copy of TSD. In this situation, you must wait until the deployment is complete.

Java Installer deployment

Q: I'm trying to deploy Java using the configuration file, but it comes to nothing. Am I doing something wrong?

A: A number of errors in Java Installer may prevent normal deployment of Java Runtime Environment and Java Development Kit on target computers. One problem is with the INSTALLCFG command line parameter which only accepts the absolute path to the configuration file. So, it accepts neither a network path nor a relative path (i.e. if the configuration file is in the installer folder).

The best solution available at this time is provided below:

  • Create a batch file with the following content:

for /f "Tokens=3*" %%I in ('reg query "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" /v "Common AppData"') DO set CommonAppData=%%J
IF NOT EXIST "%CommonAppData%\Oracle\Java" MKDIR "%CommonAppData%\Oracle\Java"
IF NOT EXIST "%CommonAppData%\Oracle\Java\java.settings.cfg" @ECHO INSTALL_SILENT=1>"%CommonAppData%\Oracle\Java\java.settings.cfg"

  • Before adding the batch file into TSD, place it into a separate folder and copy the Java installation configuration file into this folder.
  • Also add a command to the batch file to copy the configuration file into an existing folder on the target computer. Keep in mind that the configuration file will be copied along with the batch file to the target computer during deployment; i.e. both files will be placed in the same folder.
  • Add the batch file to TSD as a multi-file installer; select the folder that contains the two files.
  • In the Software editor, add the Java installer as an add-on, and set the path to the folder containing the configuration file (i.e. the folder where the configuration file will be copied by the batch file) in the command line parameter INSTALLDIR.
  • Add another batch file as an add-on to delete the configuration file that was copied.

Q: I've added parameters from the configuration file to the Java command line, but during deployment nothing happens on the target computer even though TSD reports successful deployment. What can be done?

A: Due to an error in Java installer, when it's run as System (and that is the way during remote deployment), it cannot create the temporary configuration file. See the solution:

  • Add a batch file with the following content to TSD:

for /f "Tokens=3*" %%I in ('reg query "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" /v "Common AppData"') DO set CommonAppData=%%J
IF NOT EXIST "%CommonAppData%\Oracle\Java" MKDIR "%CommonAppData%\Oracle\Java"
IF NOT EXIST "%CommonAppData%\Oracle\Java\java.settings.cfg" @ECHO INSTALL_SILENT=1 AUTO_UPDATE=0>"%CommonAppData%\Oracle\Java\java.settings.cfg"

  • In the Software editor, add the Java installer as an add-on.

Q: Can I uninstall an old version of Java using your program?

A: Yes, however, it will be necessary to find out the name of the old version of Java on the target computer. Create a batch file similarly to the example and specify the exact name of the version that should be uninstalled between the single quotation marks:

wmic product where "name = 'Java 8 Update 66'" call uninstall /nointeractive
wmic product where "name = 'Java SE Development Kit 8 Update 66'" call uninstall /nointeractive

Preparing to deploy MS Office Click-to-Run

Q: I have a box version of MS Office 2013 (2016). How can I deploy it?

A: To deploy retail editions of MS Office, follow these steps:

  • Copy disc contents (distribution folder) to the computer.
  • Download Microsoft Office Deployment Tool for your version of Office from the official website.
  • Extract officedeploymenttool.exe.
  • Place the extracted contents into the MS Office distribution folder replacing setup.exe.
  • In TSD, add setup.exe to the Software storage as a multi-file installer by ticking the checkbox and specify the path to the Office distribution folder.
  • For information on how to further setup and deploy MS Office, see the Configuration files for installers section and also the hint in the Software editor.

Q: I'm missing the Click-to-Run executable, MS Office 2013 (2016) distribution and Microsoft Office Deployment Tool. What can I do?

A: To obtain the required files for Click-to-Run deployment, do the following:

  • Download Microsoft Office Deployment Tool for your version of Office from the official website.
  • Extract officedeploymenttool.exe into an empty folder.
  • Add extracted setup.exe to the Software storage as a multi-file installer by ticking the checkbox and specify the path to the folder containing the files extracted from officedeploymenttool.exe.
  • For information on how to further setup and deploy MS Office, see the Configuration files for installers section and also the hint in the Software editor.


Feedback and support

Please contact us if:

  • You've found a bug in our program — we'll fix it!
  • You'd like to see new functions added — describe the situations they can help you in.
  • You dislike something about our program — tell us how to improve it.
  • You like something about our program — it's important for us to know, what exactly!
  • You have any technical or financial questions — our answer will be fast, polite and clear.

Your feedback is very important to us, your comments define the ways we improve our software. We'd be grateful for any message!

Sending feedback from the software

The Feedback button in the top right corner of TSD's window opens the quick feedback form.

Don’t forget to include your name and email address — otherwise we won’t be able to reply to you.

Support page on the Softinventive Lab website

Welcome: www.softinventive.com/support/

E-mail support

Technical support: support@softinventive.com
General questions: info@softinventive.com
Financial questions: sales@softinventive.com

Online support

You can rely on our assistance whenever you need it. Our technicians can be contacted via instant messengers.

softinventive

Social networks

Follow us online!

softinventive.lab
@Softinventive


Updates

TSD updates regularly. To make sure that you have the latest version, use the Help / Check for updates option from the main menu. Furthermore, the program automatically checks for updates on launch, but no more than once a day.

If an update is found, you'll see a list of changes in the new version. Click Start download and Install update after the download is complete. The program will be closed and restarted after the update has been applied.


Trial version limitations

Total Software Deployment is distributed as shareware.

The evaluation version of Total Software Deployment has 3 limitations:

1. The program only works for 60 days after its first launch on a computer.
2. The maximum number of scanned computers (network nodes) allowed to be kept in the Network storage is limited by 50 nodes.
3. The maximum number of software that can be deployed simultaneously is limited by 5 deployment packages.


Software storage

Storage concept

In TSD, the Software storage is a folder on a computer selected by user.

A separate folder is created for every software added.

The folder structure inside the Storage does not replicate the structure of the groups created by user in the Software tree.

For the program to function correctly, do not delete, move or rename auxiliary hidden files in the Software storage root. This may lead to data loss or corruption.

Storage contents

Contents of auxiliary files

  1. Data on the structure and names of categories in the Software storage tree, titles of the software and additional installers contained in these categories, as well as data from installers and the software deployment history;
  2. Storage file backup;
  3. Data on the stored lists of deployed software.

Contents of a software folder ("Soft*")

  1. The "Installer" folder containing the installer and the TSDUpdatesOfSoftware folder, which contains add-on installers;
  2. Icon files: Soft*.16.ico (16x16 pixels) and Soft*.64.ico (48x48 pixels);
  3. The Silent method's script file Soft*.clr;
  4. The Macro method's recording file Soft*.jhr;
  5. The Sysshot method's recording files Soft*.pkg and Soft*.rsr;
  6. The "Screenshots" folder containing Macro method’s screenshots and the "SmallImgs" folder which contains thumbnail versions;
  7. The "History" folder containing the deployment history logs.

Folder contents vary depending on which particular methods have been recorded and whether software has been deployed.

Storage management

A copy of TSD is not linked to any particular Storage. This means that you can switch between Storages when the program is running.

Storage management is carried out from the Storage menu:

  • Create: select an empty folder on a computer and create an empty Storage there;
  • Open: select a folder containing a previously created Storage to work with;
  • Recent: contains a list of recently opened Storages, which allows to quickly switch between them;
  • Reload: reads the data from the computer again, if the changes made to the currently opened Storage have not been automatically registered by TSD;
  • Close: closes the Storage.

To quickly locate the folder containing the current Storage or a particular software file, you can use the Show in Explorer option in the context menu of the Software tree.
It's possible to create a Storage in a shared folder and have several copies of TSD connected to it from different computers. Keep in mind that simultaneous access to the same Storage by different copies of TSD is not supported.

Data import

Importing of data is not supported by Software storage.


Network storage

Storage concept

In TSD, the Network storage is a folder on a computer selected by user.

Each network asset is represented by an .inv file.

The folder structure inside the Storage replicates the structure of the groups created by user in the Network tree. Any direct changes to the Storage contents shall be registered by the program.

It means that you can create, delete and rename groups, move and delete asset files either using TSD's tools or via any file manager. Furthermore, its design makes it possible to back-up and share data with other TSD users, etc.

For the program to function correctly, do not delete, move or rename auxiliary hidden files in the Storage root. This may lead to data loss or corruption.

Do not rename asset files (*.inv). See the Network tree section to learn how to change displayed names.

Storage contents

Contents of auxiliary files

  1. Logins for access to assets (encrypted);
  2. Storage properties.

Contents of an asset file (*.inv)

  1. Asset network identifiers (network name, IP address, MAC address);
  2. Properties (alias, type, description, inventory number, etc.);
  3. Asset configuration snapshots, collected as a result of scanning;
  4. The alias of the login assigned to the asset;
  5. The ID of the user assigned to the asset;
  6. The asset’s local user information;
  7. Special field values.

Asset files can be moved between Storages. However, various Storage data will not be moved. For instance, the remote access login will be lost, but it could be restored manually.

Storage management

A copy of TSD is not linked to any particular Storage. This means that you can switch between Storages when the program is running.

Storage management is carried out from the Storage menu:

  • Create: select an empty folder on a computer and create an empty Storage there;
  • Open: select a folder containing a previously created Storage to work with;
  • Recent: contains a list of recently opened Storages that allows to quickly switch between them;
  • Properties: opens the current Network storage properties;
  • Reload: reads the data from the computer again, if the changes made to the currently opened Storage have not been automatically registered by TSD;
  • Close: closes the Storage.

To quickly locate the folder containing the current Storage or a file representing one of the devices, you can use the Show in Explorer option in the context menu of the Network tree.

It's possible to create a Storage in a shared folder and have several copies of TSD connected to it from different computers. Keep in mind that simultaneous access to the same Storage by different copies of TSD is not supported and could lead to irrelevant information being displayed.

Data import

Importing by moving or copying data files

To import assets that have been scanned by any version of TSD, simply copy the .inv files representing these assets into the Storage folder. If TSD is running and connected to this Storage at the moment, the new files will be imported immediately. Otherwise, the files will be imported the next time TSD is started and the Storage opened.

To locate the Storage folder, right-click the Storage root group in the Network tree and select Show in Explorer.

Importing files and folders

To import one or several assets, right-click a group or the root node of the Network tree and choose Import / Import files..., then select the data files to import. This will place the specified assets into the group that you initially right-clicked.

To import the contents of a folder including subfolders, do the same, but choose the Import / Import folder... command instead. After you’ve specified the source folder, you'll be prompted to choose whether to import the folder structure. If you choose to do so, groups will be created in your Storage to match the contents of the source folder. Otherwise, all the assets found in the source folder and its subfolders will be placed in the group you initially right-clicked.

These commands are also available from the main menu Storage / Import when the Storage is opened.

Compatibility with TNI 3 Storage

TSD Network storage has the same format as TNI 3 Storage, which means that TNI 3 storages can be used in TSD and vice versa. When using a storage from TNI, only Windows nodes will be displayed. Devices of other types will be hidden from display in the Network tree; however, they will remain in the storage. License restrictions will affect Windows nodes only. For example, if you have 200 nodes in your TNI storage, of which 40 are Windows nodes, then you only need a 50 node TSD license to work with this storage in TSD.

It's also possible to work with the same storage in both TNI 3 and TSD. If changes are made in one of the programs, they will be detected in the other, and the information about display nodes will be updated. When working in TSD, TNI-specific data will not be affected and will therefore remain up to date.

Topics:

  • Network storage properties


Network storage properties

The properties of the current Network storage can be edited by selecting the Storage menu in the Network tree and then Properties.

Basic properties

A Storage name is its current title displayed in the Network tree and other places.

A Company name and a Company logo are only used in TNI for printable reports.

To add a logo:

  1. Prepare an image (JPEG, BMP, GIF or PNG). It's advisable to have a logo of reasonably good quality and with a white background.
  2. Click Add and select the prepared file.
  3. Crop unnecessary parts of the image in the editor that appears.
  4. Click OK.

Use the buttons to the right of the logo to load another image or remove the logo.

Scan settings

Settings governing the snapshot storing policy and criteria for distinguishing assets in the current Network storage.

They allow to:

  • Limit the number of stored snapshots;
  • Delete/keep the first snapshot of a device;
  • Select the method of distinguishing assets.

All changes made during editing will be saved only after clicking Apply changes in the top area of the editor.

Clicking Undo reverts the changes to the state before editing.

Changes to the logo are applied instantly, and have no effect on the Apply changes and Undo buttons.


Workspace

Introducing the main window

  1. The Software tree
  2. The Network tree
  3. The Main area

The right side of the Main menu contains:

  • The Feedback menu;
  • The Options button;
  • The language switcher;
  • The Help menu, which contains tools that allow to check for updates, register your copy of TSD and upgrade your license.

You can alter the widths of the Network tree and the Software tree by dragging their edges.

Basic operations with the Software tree

The Software tree displays the contents of the currently opened Software storage.
To create a new category, right-click any other category node or the empty area in the tree and select

To move software into a new category, first select them (using your mouse's Rectangle selection or keyboard keys Shift and Ctrl) and then drag them onto the group node. Alternatively, you can use the Move to category option from the context menu of a software node.

Double clicking on the software node will switch TSD to the Software editor mode.

See the Software tree section for information on searching software and on package indicators.

Basic operations with the Network tree

The Network tree displays the contents of the currently opened Network storage.

To create a new group, right-click the parent group or Storage root and select Create group. To move some assets into a new group, first select them (using your mouse's Rectangle selection or keyboard keys Shift and Ctrl) and then drag them onto the group node. Alternatively, you can use the Move to group option from the context menu of a node.

Groups in the Network tree replicate the structure of directories on the hard drive as described in the Network storage section. Thus, operations such as creating, deleting or renaming groups and moving assets between them can be performed in any file manager.

See the Network tree section for information on searching in the Network tree, displaying additional text and graphic data in it and filtering assets according to various criteria.

TSD's view modes

There's a separate view mode in TSD for each specific task. View modes can be switched by clicking on tabs above the main area.

Pressing Ctrl + <tab number> provides quick access to the desired view.

Software deployment Ctrl + 1 | Both Storage trees are displayed. The Main area contains the Deployment desktop. This mode offers the tools that help: deploy software; collect information about software and computers; search for software on remote computers; search for software installed on remote computers in the Software storage; view the software deployment history; manage lists of software and computers. Read more: Deployment desktop.
Software editor Ctrl + 2 | The Software tree is displayed. The Main area contains the Software passport and the deployment method area. The Software passport contains main software information, which is available for editing. The deployment method area contains 3 tabs: Silent, Macro, Sysshot, which allow to record or edit the corresponding deployment methods for the selected software. Read more: Software editor.
Scanner Ctrl + 3 | The Network tree is displayed. The Main area contains a set of available scan tasksin the Sidebar and the task area. Before any of the information on remote assets becomes available for viewing and building reports, these assets have to be scanned. The Scanner view makes gathering asset information a breeze. TSD can collect information from Windows computers. See the White paper section on how to ensure that all the conditions for successful scanning are met. Read more: Network scanning.


Software tree

The Software tree displays the contents of the currently opened Software storage.

Main elements:

  1. Software tree toolbar;
  2. Main area;
  3. Software title;
  4. Deployment method indicators.

Under the Software tree is the status bar where a few more indicators are displayed:

The 1st one represents the number of programs in the Storage.
The 2nd through 4th represent the amount of stored deployment packages of each type.

Topics:

  • Altering the Storage structure
  • Searching software
  • Package indicators


Altering the Storage structure

The Software tree allows to create, rename and delete software categories.

Creating a category

To Add a category, use the option from the context menu of either an existing category or the empty area in the Software tree.

Renaming a category

Click Rename in the context menu or select the category and press F2. Type the desired name and press Enter.

Adding software

Click the Add button in the Software tree toolbar or use the appropriate option from the context menu of an existing category.

Specify the path to the installation file in the dialog box:

If the installer consists of more than one file, tick the checkbox and point to the installer folder.

Then TSD will switch to the Software editor mode (the Software editor tab is available from TSD window’s main menu or by pressing Ctrl + 2).

Moving software to a category

When it's necessary to move multiple programs, select them using either your mouse or keyboard Shift and Ctrl.

Perform one of the following operations:

  • Drag the selection using your mouse and drop onto the category title;
  • Right-click one of the selected nodes and use the context menu option Move to category.

Deleting software and categories

To delete one or several programs or categories, select them and press Delete on your keyboard or use the Delete option from the context menu.

Warning! Deleting software is an irreversible operation. All the data connected to the deleted software will be permanently lost. Consult the Contents of a software folder section to find out what exactly is being deleted.

Warning! Deleting a category means all the software inside will be deleted along with it.

The Storage folder structure does not replicate the structure of categories inside the Software storage tree. Therefore, creating, deleting or renaming the files inside the Software storage folder is not advised and may lead to data loss or corruption.


Searching software

To start searching the Storage, click the Find button on the Software tree toolbar. The search field will appear below the toolbar.

Matching text is instantly highlighted as you type:

The contents of the Software tree are filtered to only display the software and categories which match the query, and the rest is hidden.

If the queried text matches a category name, all the software in that group is displayed.

You can use the up and down arrow keys when the search field is in focus to navigate the Software tree.


Package indicators

Indicators for each of the deployment methods are displayed in front of each node in the Software tree.

Each indicator links to the Software editor page of the corresponding method. If the indicator is semi-transparent, the package has not been created yet. If the indicator is opaque, the package has been created and may be edited. Another way of accessing the editor for a particular method is by using the Open in software editor option from the individual context menu.

If the software has no deployment packages yet, 'unrecorded' will be displayed in place of indicators. To show the indicators, hover over the text with your mouse.

Under the Software tree is the status bar where a few more indicators are displayed. The 1st one represents the number of programs in the Storage. The 2nd through 4th represent the amount of stored deployment packages of each type.


Software editor

The Software editor mode is activated by selecting the corresponding tab in TSD window's main menu or by pressing Ctrl + 2.

The Software editor allows to fill in software information and create deployment packages.

When new software is added to the Storage, Total Software Deployment switches to the Software editor mode automatically.

Switching to the Software editor is only possible when the Software storage has been opened

Topics:

  • Software passport
  • Deployment package


Software passport

Filling in software information

Total Software Deployment imports basic software information from the installer. Verify the information and fill in the empty fields in the Software passport.

Here you can specify:

  • The displayed name;
  • Program version;
  • Program language;
  • Program bitness.

Also, the passport allows to:

  • Load an alternative icon;
  • Open the folder containing the program installer and other data in Explorer;
  • Set a software search string;
  • Add add-on or update installers etc.

Information from the Version and Software name search fields is used by the Assistant for finding software on network computers. The Software name search string is also used when editing Sysshot deployment packages.

Program bitness

Program bitness is one of the most important factors during deployment. It's important to set correct bitness to safeguard from possible errors if the wrong deployment target was selected.

After adding a program to the Software storage, select its bitness by clicking Set program's bitness in the passport. If bitness has not been set, TSD will keep prompting you to set it during editing. Programs with unset bitness will not be allowed to be deployed.

We recommend to make sure that bitness is correct for the installed program before setting it. Deployment of 64-bit programs on 32-bit operating systems using Sysshot can lead to unforeseen consequences, up to and including OS failure on the target node (deployment of 32-bit software on 64-bit operating systems is normal). When deploying using the other methods, correct bitness setting will save you from receiving additional irritating deployment errors, since 64-bit software will most likely not be installed on a 32-bit OS.

If you're not sure whether your program is 32-bit or 64-bit, you can let TSD detect it from the executable if the program is installed locally. In this case, it's most convenient to do it after a local Silent test run or after recording a macro or making a sysshot. To do this, click Check for me and browse to the program's executable file.

Some installers may be able to install both the 32-bit and the 64-bit version of the program and establish a program of the same bit depth as that of the operating system on which they were launched. For such installers, we recommend to set the bitness at 32 bit.

Do not detect bitness based on the installer: it may have different bitness than the program it installs. For example, a 32-bit installer may install 64-bit software.

Add-ons

The list of add-ons allows to add additional installers for add-ons, updates etc.

Installers located in the list of add-ons will automatically be added to the deployment package. When recording the package, additional installers will automatically start after the main installer.

The buttons under the list allow to add and remove installers from the list and change the installation order.

If Macro and/or Sysshot methods have already been recorded for a particular program, then editing the list of add-ons will necessitate rerecording of these methods. Silent installation will not be affected.


Deployment packages

Total Software Deployment offers 3 methods for creating deployment packages:

Each method has its advantages and disadvantages.

We recommend to start with the Silent method as the easiest to use and the most reliable. The method selection is in the top area of the Software editor.

Topics:

  • Silent
  • Macro
  • Sysshot


Silent

Most modern installation packages support the silent installation mode. In this mode, software is installed without user interaction: all processes are performed automatically.

In most cases, this mode is enabled by adding parameters to the command line of the executable. The installation package accepts these parameters, and the program is installed without user interaction.

Creating a method

Go to the Silent tab. Click Create command file under the method selection bar.

TSD tries to automatically determine the type of the installer and, if successful, inputs a set of parameters required for silent installation into the Parameters field. If TSD could not determine the type of the installer automatically, you can manually select it from the Installer type drop-down list.

The Redetermine the installer type [image] button automatically re-detects the type of the installer. The available parameters will be then refreshed, but the Parameters field will not be filled.

When the type of the installer has been selected, all available parameters for this installer type will be displayed in the area under the Parameters field. Clicking one of the parameters will add it to the end of the Parameters field. Parameters can be edited manually.

A parameter can contain a value. In such a case the parameter and the value's macro (highlighted for editing) will be added to the Parameters field.

The Set default command line for the silent install [image] button fills the Parameters field with the basic parameters required for the selected installer type.

Ticking Use empty command line erases the contents of the Parameters field, disables its editing and disables the Installer type drop-down list. The method is considered ready for deployment.

The method is saved after every edit to the Parameters field.

The Silent method does not fully support:

  • Online downloaders may have parameters that allow the downloader to operate without user intervention, but at the same time the downloadable installation package is either run without any options or the downloader’s parameters are not compatible with it;
  • Self-extracting archives may have parameters that allow the downloader to extract the contents without user intervention, but at the same time they may not be designed to make the installation package run with the required parameters;
  • Installation packages where silent installation is either not supported or intentionally disabled during package creation.

Configuration files for installers

Certain installer types involve the use of configuration files that allow to modify installation settings. Currently, TSD supports deployment of one such type of installer: Microsoft Office Click-to-Run.

Microsoft provides MS Office Click-to-Run installers separately from MS Office as Office Deployment Tools. At this time, the version of Click-to-Run supports Office 2013 and 2016. TSD does not support deployment of any other MS Office installation files. Pay attention to the Silent installation information panel and, if necessary, follow the instructions.

Only multi-file software can work with configuration files.

When you edit the method, and the configuration file is not present in the Software storage folder, then the default configuration file will be created. It's also possible to import an external configuration file.

To import the file, press the button:

The configuration file editor has two modes: standard and advanced.

Standard mode shows configuration file contents necessary for silent installation in simplified, user-friendly form.

If you need to install multiple languages or exclude multiple applications from Office installation, you can do so by using comma as a delimiter.

To switch to Advanced mode, press:

Advanced mode allows to manually edit the configuration file from a special text editor directly in TSD. For more information about the structure of the configuration file, see Microsoft Office documentation.

The changes to the configuration file must be confirmed by clicking Apply Changes.

If the .xml configuration file becomes invalid after manual editing, only editing in Advanced mode and external file importing will be available, but not standard mode. If the configuration file is valid, but lacks necessary data, then the missing lines will automatically be added with default values for display in standard mode.

While using the configuration file edited from TSD, you don't have to specify the path to it from the command line. Both during the test run and during deployment, this file will be used automatically. However, at the same time, you can set the parameter to point to another file; in this case, the file from the specified path will be used.

Timeout

During remote deployment, certain factors (e.g. wrong command line or installer without silent installation support) can hang software deployment, and there would be no end to waiting for the installer to close. To solve this problem, we introduced installer Timeout to the TSD service. When the timeout period elapses, the service interrupts the wait for the installer to close and aborts its process.

Each newly created method has the default timeout value in minutes, which can be changed in Options - Deployment methods. Timeout is used during test runs and during deployment. For smaller programs, where the installation process will not take much time, the timeout value can be reduced so that, if unforeseen happens, you're not forced to wait for the process to close for much longer than necessary. If you're deploying a large size application, or know that the program will take longer to install, increasing the timeout value is recommended to give the software enough time to deploy on the target machine. Otherwise, deployment will be interrupted prematurely before all its activities are performed.

Remote software deployment may take longer than normal local installation depending on software size and internal operations during installation, as well as external factors.

Changes to the default timeout value will not affect timeout values that have been set manually, even if their values match.

In order to default the timeout value in the editor, clear the field and press Enter.

If a value is outside the acceptable range, the closest possible will be set.

Test run

The installer that uses correct silent parameters should not interact with the user in any way.

To verify correct behavior of the installer with set parameters, use the Test run (local) option located under the Installer type drop-down list. A test run is considered successful if the user didn't have to input anything during installation.

TSD monitors the tested installer and displays its status in the Silent section header.

The installation doesn't have to be "silent", as being automatic should be sufficient.

Monitoring installer processes

It's important for TSD to know when the installer completes its operation in order to provide all the necessary automatization during test run and to know when to start deploying the next program when deploying several programs. That's why the main installer process is monitored during a test run or Silent deployment. If the main installer leaves behind any child processes, a list of all the monitored child processes will be displayed.

Such a scenario may occur if, for example, the installer finished by opening the developer's website page in the browser or if the basic process was a self-extracting archive, and installation will be performed by a child process. Test run will stop automatically when all the processes from this list close, or by pressing the Installation is complete, stop monitoring button. Child processes which have not closed before the button is pressed will be ignored during deployment.

Given the nature of the silent installation, verification of installation should be carried out by running the program.

Add-ons

If add-ons have been attached to the main installer, a separate command line is created for each of them.

If any of the command lines is not filled and the box is unticked, the method is not considered ready for deployment.

Silent execution of batch files

It's possible to work with batch files in TSD, however not in order to run software installers, but as sets of commands to be carried out before and/or after the main software installer. It's recommended to use batch files as Add-ons to software installers.

We strongly recommend not to run software installers through batch files. Software deployment using .bat or .cmd files will not finish correctly in some cases, because it will be impossible to fully control the installation progress by monitoring the installer process, which can lead to unforeseen consequences on the remote computer. To deploy a program as well as carry out certain commands in CMD, add installers and batch files separately using the list of Add-ons.

In most cases, if a software publisher provides an installer in the form of a batch file, silent installation parameters will not be required. If however they are, please contact the software support and ask for instructions on silent installation.


Macro

This method is designed to work with installers equipped with standard Windows controls. Its mechanism is based on recording user actions during the installation for future playback on a remote computer without disturbing the remote user.

Recording a method

Make sure the program hasn't already been installed locally. Also, close all running applications and stop the antivirus.

Proceed to the Macro tab and click Record right next to it.

The TSD window will be minimized and the Macro recording window will be displayed.

After clicking Record, simply install the program.

It's not recommended to set the install location using Browse, as the interface of the Browse window on a remote computer, as well as folder structure, may differ from yours. To prevent such behavior, use Browse (the yellow folder button) in the Macro recording window.

This will allow you to choose the installation path so that browsing for path is not recorded. Then simply press Insert into the focused field (the button with the blue arrow pointing down), and the installation path will be inserted into the Browse field in the installer.

To the right of the Browse button is Paste from clipboard, which will paste your last copied text.

When the installation is complete, click the Floppy/Save the macro button.

During recording, additional installers will automatically start after the main installer. Both the main installer and its add-ons will be packaged together.

The Macro method doesn't support non-standard controls such as:

  • Internet ads and requests to install extra utilities, which are downloaded from the Internet;
  • Pseudo-container controls that can emulate behavior of several controls at once.

Monitoring installer processes

It's important for TSD to know when the installer completes its operation in order to provide all the necessary automatization when recording the macro and to know when to start deploying the next program when deploying several programs. That's why the main installer process is monitored during recording, and the recording ends when this process ends. If the main installer leaves behind any child processes, TSD will prompt the user to ask whether the installation is complete.

Answering 'no' effectively means that the macro recording is over.

The negative answer will be saved, and only the main installer process will be monitored during deployment. Such a scenario may occur if, for example, the installer finished by opening the developer's website page in the browser.

When the answer is 'yes' – for example, if the basic process was a self-extracting archive, and installation will be performed by a child process – a list of all the monitored child processes will be displayed. Recording will stop automatically when all the processes from this list close, or by pressing the Installation is complete, stop monitoring button. Child processes which have not closed before the button is pressed will be ignored during deployment.

Installers often have an option to run the installed program. If you continue to monitor this process, it's possible to make changes to program settings before stopping recording, and these changes can be deployed along with the program on the target nodes.

Non-standard controls are more common in programs than in their installers. If you interact with such controls when changing settings, you will receive the appropriate warning after recording, and you won't be able to deploy this macro.

Editing the deployment package

After recording the method, you can view all the actions recorded during the installation. The result can be edited to eliminate accidental or unnecessary actions.

The macro editor contains:

  1. The header;
  2. The Macro window strip;
  3. Selected window's screenshot;
  4. The list of actions in the selected window.

The recorded Macro package displays the following information in the header:

  • The date and time of recording;
  • Operating system it was recorded on, and its architecture;
  • The number of steps and actions;
  • The filesizes of the deployment package and of the separate installers.

To the right are two buttons: Rerecord and Delete.

The list of actions contains action descriptions and the name of the window/control where the action took place. All actions can be enabled/disabled: either in bulk by using the Process actions in this step checkbox, or by using separate checkboxes.

The deployment package is saved after every operation.

To display actions from a different window, select it from the Macro window strip.

After recording the deployment package, the installed program may be uninstalled.


Sysshot

This method is suitable for small programs or tools. During package creation, the program will be installed locally. By analyzing two system shots (before and after the installation) TSD determines the changes made in the system and saves them for future deployment. The method may accidentally record changes made by the system or another background application or service. Therefore, take care when using this method.

This method is only recommended for professional system administrators, because using an incorrect system shot for deployment may cause irreparable damage to target systems.

TSD developers assume no responsibility for attempts to deploy the following using Sysshot:

  • System drivers, codecs, system libraries;
  • Other software that interacts with particular hardware.

Recording a method

You need to make sure the program isn't installed locally before recording. Also, close all background and foreground programs.

Proceed to the Sysshot tab and click Record.

The TSD window will be minimized and the Sysshot recording window will be displayed.

Sysshot monitors system folders and saves a list of changes to important registry keys. The monitored folders can be enabled, disabled or added from Settings accessed by pressing the gear icon.

After pressing Record, wait for the first system shot to be taken and install the program as usual. The second system shot will be made automatically and the results will autosave.

During recording, additional installers will automatically start after the main installer. Both the main installer and its add-ons will be packaged together.

Monitoring installer processes

It's important for TSD to know when the installer completes its operation in order to provide all the necessary automatization when recording the macro. That's why the main installer process is monitored when recording Sysshot, and the recording proceeds to another stage when this process ends. If the main installer leaves behind any child processes, TSD will prompt the user to ask whether the installation is complete.

Answering 'no' effectively means that the recording of the first system shot is over.

Following the negative answer, the second system snapshot will be taken, the two snapshots will be compared and the method saved. Such a scenario may occur if, for example, the installer finished by opening the developer's website page in the browser.

When the answer is 'yes' – for example, if the basic process was a self-extracting archive, and installation will be performed by a child process – a list of all the monitored child processes will be displayed. The second system snapshot will be taken automatically when all processes from this list close, or after pressing the Installation is complete, stop monitoring button.

Installers often have an option to run the installed program. If you continue to monitor this process, it's possible to make changes to program settings before stopping recording. These changes can be deployed along with the program on the target nodes if they were saved into one of the monitored folders.

Editing the deployment package

After the deployment package is compiled, TSD will display the result in the form of a list with all the changes that have occurred in the registry and in the file system during the recording. The list can be edited to eliminate the changes made by system services or by background programs.

The Sysshot editor contains:

  1. The header;
  2. Package display settings;
  3. The list of changes in the registry and file system.

The recorded Sysshot package displays the following information in the header:

  • The date and time of recording;
  • Operating system it was recorded on, and its architecture;
  • The number of changes in the registry and file system;
  • The filesize of the deployment package.

To the right are two buttons: Rerecord and Delete.

The list with results contains 2 main elements: Files and Registry keys.

The first one shows what changed in the file system of the monitored folders, which can be edited in TSD Settings.

The second one displays the changes that occurred in important registry keys.

Each change or group of changes can be disabled/enabled by ticking the corresponding box.

The deployment package is saved after every operation.

To set up the display rules for enabled/disabled changes, use the Show filters.

Enabling the first (default) option makes all changes visible.

The second option hides the "enabled" changes.

The third option hides the "disabled" changes.

To highlight the changes made by the installed program, enter its title into the Search string field.

Press Save to copy the entered text into the Software name search field of the Software passport.

To the left of the list of changes is the vertical bar where the Expand button appears in front of every folder where a match with the Search string was found. Click the button [image] to expand the list to the node which matched the query.

After recording the deployment package, the installed program may be uninstalled.


Network tree

The Network tree displays the contents of the currently opened Network storage.

The Network tree only displays the devices running on Microsoft Windows. Other devices are not displayed in the tree, and their presence in the Storage does not affect your license restriction.

Main elements:

  1. Network tree toolbar;
  2. Main area;
  3. Additional text output;
  4. Assistant information icons.

Below the Network tree is the status bar where several indicators are displayed:

The first of them shows the number of devices in the tree. The maximum number of these devices is limited by your license.

The second indicator shows the number of unscanned devices. The third one is the number of devices allowed by your license.

Topics:

  • Altering the Storage structure
  • Information display settings
  • Searching in the Network tree
  • Storage assistants
  • Synchronization with Active Directory


Altering the Storage structure

The Software tree allows to create, rename and delete software categories.

Creating a group

  1. Right-click the parent group (to create a first-level group, right-click the root node);
  2. Click Create group in the context menu;
  3. Type the name of the group and press Enter.

Renaming a group

Click Rename in the context menu or select the group and press F2. Type the desired name and press Enter.

Moving nodes into a group

  1. If you need to move multiple nodes, select them using your mouse's Rectangle Selection or your keyboard's Shift and Ctrl.
  2. Do one of the following:
  • Drag the selection with your mouse and drop it onto the title of the target group;
  • Right-click one of the selected nodes and use the Move to group menu item.

Deleting network nodes and groups

To delete one or several nodes or groups, select them and press Delete on your keyboard or use the Delete option from the context menu.

Warning! Deleting a network node is an irreversible operation. All the data connected to the deleted asset will be permanently lost. Consult the Contents of an asset file section to find out what exactly is being deleted.

Warning! Deleting a group is not the same as "ungrouping". All the assets inside the group will be deleted as well.

Working with storage files directly

The Network storage structure fully replicates the structure of files and directories inside the Storage directory, as described in the Network storage section. Therefore, it's possible to create, delete or rename groups and move assets between them by performing corresponding operations over file system objects, which can be done in any file manager. TSD will react to these changes automatically.

Right-click any node and choose Show in Explorer to quickly locate a directory or file corresponding to the node. This will launch an instance of Windows Explorer navigated to the target directory. If the selected node is an asset node, its file will be selected.

You can also use this function when backing up data, copying, transferring to another TSD user, etc.


Information display settings

Additional information displayed in the Network tree can be selected in the Tree display settings menu, located on the Network tree toolbar.

For instance, setting hostnames as node names and selecting IP addresses for the additional field will result in the Network tree looking like this:

Both node names and the additional fields are used when searching in the Network tree.

Node names

Pick which values will serve as node names. The following values can be displayed as the node name: aliases, hostnames, IP addresses.

If Alias is set as the node name, network nodes can be renamed by choosing Rename from the individual context menu or by pressing F2. The asset's alias will be changed.

Additional field

An additional value can be displayed in the Network tree for every node. This value is selected from the same list as for the node name.

Sorting the nodes

The Sorting section allows to select the sorting criteria: nodes can be sorted either by their names or by the additional field values (configured as shown above), with an option to reverse the sorting order.


Searching in the Network tree

To start searching the Storage, click the Find button on the Network tree toolbar or press Ctrl + Shift + F. The search field will appear below the toolbar.

Matching text is instantly highlighted as you type:

Both node names and additional text are searched. See the Information display settings section for details.

The contents of the Network tree are filtered to only display the nodes that match the query, and the rest is hidden.

If the queried text matches a group name, all the nodes in that group are displayed.

You can use the up and down arrow keys when the search field is in focus to navigate the nodes.


Storage assistants

Storage assistants is a tool that displays additional graphic and text information in the Network tree, and also enables searching and filtering by various criteria.

When an assistant is enabled, its filter appears in the toolbar, and every node is checked against the criteria and marked with the assistant's icon that indicates its status.

Hovering the mouse cursor over an icon reveals a hint with additional information.

When the Filter is enabled, it hides all assets that don't meet the condition.

This is how the Storage may look when several assistants have been added:

Topics:

  • Working with assistants
  • Assistant list and description


Working with assistants

Adding assistants

Follow these steps to add an assistant:

  1. Click the Add Assistant button on the toolbar in the Network tree;
  2. Select the assistant type from the menu that appears;
  3. Set a condition.

Any number of assistants can be used at the same time.

The assistants are saved when TSD is closed.

Managing the added assistants

Newly added assistants appear in a separate area on the right side of the toolbar.

What the Network tree toolbar looks like when the assistants have been added:

Every added assistant has several controls:

  • The switch button Indicator/Filter. If the icon is translucent, the assistant is in the Indicator mode; if the icon is opaque, the assistant is in the Filter mode. The Indicator mode enables the corresponding icon on the right of every network node. Hovering the mouse cursor over an icon reveals a hint with additional info. The Filter mode hides all assets that don't meet the assistant's condition.
  • The Remove assistant button. All assistant options can be accessed via the drop-down menu.

In case you can't find an asset that exists in the storage, make sure it has not been filtered out by one of the active assistants.

The Filter and Indicator toggles cannot be enabled simultaneously.

By default, assistants are added as Indicators.


Assistant list and description

There are 3 assistants in TSD: Online status, Operating system and Scan status.

Online status

TSD pings all the assets in the Storage once every several seconds, and this assistant is used to display the result in the Network tree.

In the Filter mode this assistant only shows the nodes with the specified status (online or offline).

Operating system

The Indicator displays the icon representing the installed OS and its version. The full title of the OS can be found in the hint.

The Filter hides all assets that run on a Windows OS version different from the one specified.

Scan status

The Indicator displays an icon that displays whether the scan has been completed successfully or not.

In the Filter mode the user chooses to display either the devices that were scanned successfully or the ones scanned unsuccessfully.

If you've got a suggestion for a new assistant type, feel free to send us a message! Use the main menu option Feedback / Feature request and tell us. Perhaps, next update you'll find your assistant in the program.


Synchronization with Active Directory

Synchronizing with Active Directory allows you to automatically transfer the OU structure to your Network tree. A group will be created for each OU in the current domain, and each computer in the domain will be moved to its proper place in the structure.

To perform AD synchronization, right-click the Storage root and choose the corresponding option:

Placeholders will be created for each device discovered in the domain but not yet scanned. These placeholders are empty nodes that can be rescanned to retrieve inventory information. They will be displayed in the Network tree as:

You also get to choose which action to take if a previously scanned PC has not been discovered in the domain during synchronization: move it to a separate group or delete it.

You can configure TSD to perform synchronization on startup. This and several other switches are located in Options - General.

Active Directory synchronization is one-way only: it's only possible to import data from AD to TSD at this time.


Network scanning

The Scanner mode is activated by clicking the corresponding tab over the main area of TSD's window or by pressing Ctrl + 3.

Scanning in TSD is a process of data collection from remote assets and saving it to the current Storage.

When the program scans an asset not present in the Storage, a new node is created for it. Assets that are already in the Storage can be scanned repeatedly to update with the collected information.

The Scanner mode is available only when the Network storage is opened

Topics:

  • Adding scan tasks
  • Managing added tasks
  • Managing logins
  • Scan process and results
  • Saving, importing and exporting tasks


Adding scan tasks

Before starting a scan, you'll need to create a task list for the scanner.

There are a few ways in which this can be done.

Quick Scan

When the task list is empty, the scanner area displays help information as well as the Start quick scan button.

Quick Add

Here you can type in the following:

  • Network name
    • PC321
    • host.domain.com
  • IP-address
    • 192.168.0.1
  • Subnet
    • 192.168.0.0/24 (allowed CIDR notation number range: from 16 to 30)
    • 192.168.0.0/255.255.255.0 (allowed masks range from 255.255.0.0 to 255.255.255.252)
  • IP range
    • 192.168.0.1-192.168.0.254
    • 192.168.0.1-192.168.2.150
    • (the total number of hosts must not exceed 65536, i.e. X.X.0.0-X.X.255.255)
  • Shortened IP range
    • 192.168.0.1-254
    • 192.168.0.1,5,7
    • 192.168.0.1-50,125,130
    • 192.168.0-3,5,7.1-254
  • Windows workgroup name (prefixed with WG:)
    • WG:MSHOME
  • Domain controller
    • Hostname or IP address of a controller prefixed with AD:
    • AD:10.0.0.1
    • AD:servername
    • This works even if your PC is not in a domain.
  • LDAP notation
    • LDAP://OU=Seattle,OU=Washington,OU=USA,DC=company,DC=local
    • Only works if your PC is in a domain.
  • Shortened LDAP notation
    • There are several ways of defining an Active Directory object. These notations are converted into LDAP and can only be used from inside a domain.
    • Domain
      • DC:company
      • DC:company.local
    • Container
      • CN:Computers
    • Organizational unit
      • OU:Seattle
      • OU:Seattle.Washington.USA
  • Exception task
    • A hostname or an IP address of a node that needs not to be scanned, prefixed with a "-"
    • -APACHESERVER
    • -10.0.0.1

The Quick Add field stores the history of commands you typed in, similar to how Windows command prompt does. Browse recently used commands using up and down arrow keys.

Sidebar

The Add scan task block on the sidebar contains:

  • This PC: adds a task for scanning the computer running the current instance of TSD.
  • All assets: adds tasks for rescanning of each asset in the storage.
  • Selected assets: adds tasks for rescanning of the selected assets.
  • IP networks. This group contains automatically detected networks that your network adapters are set up to use.
  • Windows network. Here all visible Windows workgroups are listed.
  • Active Directory. Your default naming context and root domain naming context are presented here. The Connect to domain option allows to use another domain controller. It has the same effect as typing AD:<hostname or IP of a domain controller> into the Quick Add field.

Rescanning network nodes

You can create tasks for rescanning the existing nodes in several ways:

a. Simply type the hostnames or addresses of assets into the Quick Add field;
b. Select the corresponding nodes in the Network tree with your mouse or using Shift or Ctrl and drag them into the task list area:

Drag'n'dropping a group creates a task for each asset it contains.

c. Use All assets or Selected assets from the sidebar;
d. While in any mode (not necessarily the Scanner), select Rescan from the context menu of a node or a group.


Managing added tasks

Node discovery

Complex scan tasks (i.e. network scan, IP-address scan or Windows workgroup scan) work with previously discovered nodes. The discovery will be performed automatically, but it also can be done manually before scanning starts.

To perform the network discovery, just expand a complex task. The subtasks corresponding to discovered nodes will gradually show up.

Searching is accompanied by animation. It can be stopped by pressing the Stop search button.
When the search is completed or stopped, two additional buttons appear on the right:

  • Repeating the search deletes all subtasks and performs a new node discovery;
  • The Padlock icon shows the way the complex task will be saved.
    • When the padlock is opened, the task is saved without subtasks, and after reloading the search will be performed again.
      To save the task along with the customized subtasks exactly as they are before saving, click the padlock and it will "close".
      About saving scan tasks.

Setting logins

To access a remote node, the TSD scanner requires a login (username and password).

Logins for each task can be set in the Windows column.

Click on an arrow in one of the Windows cells, and the login menu will show up.

This list contains all logins created by the user and the standard login (the current user of the system where the program is run).

To scan an asset, select one of the logins or create a new one by using the Add option.

Along with the username and password, its alias should also be specified when adding a new login. This alias is the unique identifier that will be used to address this login in TSD.

To change the username and password for previously created logins, use the Edit button (the pencil icon) located in front of every login in the list.

Select Ignore to skip the asset during the scan.

Logins for single tasks

Only one login for one of the protocols can be selected for any single task. If the login is not specified, the task will be ignored during scanning.

Logins for complex tasks

Complex tasks can have several logins for each protocol. In this case, access to every asset scanned within this task will be sequentially requested using all specified logins until one of them matches.

A tilde (~) in a login cell means that the task uses the logins of a parent task, but another login can be assigned to the task, and it will be used for scanning.

During the first scan of a remote asset, the login that successfully provided access is automatically assigned to it.

Setting a login for a task created with Quick Add

A new task automatically acquires a login entered with additional semicolon-separated login command:

<task creating command>; login <login alias>

For instance:

10.0.0.3; login Homer

You can also enter several logins separated by commas:

10.0.0.0/24; login Homer, Marge

Setting the destination folder

By default, all new assets are placed in the root folder of the Storage.

You can select a folder in the Storage for every task, and the scanned assets will be placed there.

The Destination folder column serves this purpose. Clicking on an arrow in this column will show a menu with the list of all Storage folders.

It's not possible to create a new folder from this menu. If assets should be placed in a new folder, create it manually beforehand.

You can use an additional "to" command when creating a new task with Quick Add:

<task creating command>; to <path to folder>

EARTH; to Planets

10.0.0.3; login Homer; to New devices

PLUTO; to Planets\Dwarf planets

Deleting and disabling tasks, exceptions

Deleting tasks

To delete a task, use the Delete button in front of its title in the Task column or select multiple tasks and press Delete on the keyboard.

Disabling tasks

To disable a task without deleting it, tick off the checkbox in front of its title. This can also be done by selecting multiple tasks and pressing the Space bar. To enable or disable all tasks, use the checkbox in the Task column header.

You can create a new task as disabled through Quick Add by using an additional disable command:

<task creating command>; disable

HALLEY; to Comets; disable

Exceptions

You can create an exception task using Quick Add. Just enter a network name or an IP-address with prefix "-" (minus). If the exception task is enabled, the scanner will ignore the specified asset.

Exceptions are convenient to use for scanning networks and ranges. For instance, if one or several assets in the 10.0.0.0/24 network should not be scanned, you can do the following:
  1. Create a task, expand it and wait for all subnodes to be discovered, then delete the unnecessary ones;
  2. Create a task and several exception tasks.
Option (b) is sometimes faster and more handy.


Managing logins

A login in TSD is a set of username and password, which are used to access remote assets during scanning.

When creating the Network storage or opening one that doesn't have default logins set, TSD offers to set the default username and password.

Each Storage contains its own sets of logins for different protocols. TSD only works with the Windows protocol.

To display it, switch to the Scanner mode (Ctrl + 3) and click Set up logins on the sidebar.

The Login editor window consists of 2 sections:

  1. Management of Storage logins;
  2. Assignment of logins to network nodes.

Management of Storage logins

By default, there's only one standard login in this set:

  • Current user: login of the Windows user running TSD.

The standard login cannot be changed or deleted.

To create a new login, click the Add button below the list.

When adding a new login, an alias should also be specified along with the username and password. An alias is a unique identifier that will be used when working with a particular login in TSD. Aliases enable adding logins with the same usernames.

The added login is displayed in the list.

To edit a username or password, click on its field in the list. To change an alias, double-click it.

You can specify the default login by clicking the option button to the left of it. This login will be used when scanning assets for which no logins have been specified explicitly.

When changes are made in this section, two buttons appear in its header: Undo and Apply changes.

Clicking Undo cancels the unsaved changes.
Clicking Apply changes saves the changes into the Storage.

Logins can be added and edited in the Scanner mode right before scanning. For details, see the Managing added tasks section

Assigning logins to network nodes

If the network node should be always scanned with the same login, that login can be assigned to it.

To assign one of the logins to the asset, click the small chain icon to the left of the alias. The linked chain icon and blue highlighting indicate that this login is assigned to the selected asset.

Any login can be assigned to several network nodes at once. To do this, select the nodes or their group in the Network tree and select the assigned login in the list.

When changes are made in this section, two buttons appear in its header: Undo and Apply changes.

Clicking Undo cancels the unsaved changes.
Clicking Apply changes saves the changes into the Storage.

Changes made to the Default Windows login section will only be reflected in the Windows login for selected assets section when these changes are applied.

When remote assets are scanned for the first time, logins that successfully provided access are automatically assigned to them.


Scan process

The scanner control block is located at the top of the sidebar.

It displays the current status of the scanner and additional command buttons. Certain buttons may appear or disappear depending on situation.

Editing the task list

When the tasks have been added and configured, click Start scan.

  • Looped scan: performs current tasks with specified frequency.
  • Set up scanner: opens the options window.
  • Clear all: removes all added tasks.

Scanning

You can't remove, disable or configure scan tasks during scanning. All disabled tasks are hidden.
The Status column displays the progress of each task and their current states.

The overall scanning progress is displayed in the sidebar.

Click Stop scan if you want to interrupt the scan process. This operation might take some time.

You don't have to stop the scan process to add new tasks. Simply create new tasks during the scan: from the Quick Add field, by dragging assets into the scanner area or in any other way. They will be processed in turn.

You don't have to monitor the scan process. You can freely switch to a different mode and work there while the scan is performed in the background. The icon in the Scanner tab displays the scan progress.

Scan results

When the scanning is done, the results of every task are displayed in the main area.
If an error has occurred while processing any of the tasks, you'll see an error message in the Status column.
Names and statuses of tasks can be copied by selecting them and pressing Ctrl + C or via the context menu.

The sidebar displays the overall scan result and some additional commands.

  • Back to editing: dismisses the scan results and returns to normal mode.
  • Clear finished: only leaves the tasks that have not finished with success for one reason or another. This allows to eliminate the causes of errors and run the scanner again without rescanning the tasks that finished with success.


Saving, importing and exporting tasks

Saving and loading

To save a task list, click Save current tasks on the sidebar. Once saved, a task list can be loaded and used at any time.

To load a previously saved task list, click on its title in the Saved tasks list.

When a task list is loaded, its tasks are appended to the tasks already in the scanner. If you want to only load the saved tasks, clear the tasks in the scanner before loading the list.
If you need to pass a task list on to another TSD user, you can find your saved lists as separate files in the Tasks subfolder of the program's application data folder ("{Path to the Application Data folder}Total Software DeploymentTasks"). It can be accessed by clicking the Open tasks folder link on the sidebar in the Scanner mode.

Importing and exporting

Task lists can be exported to a file or imported from it.

To export the current task list click Save tasks to file. You can choose between file extensions .task-list and .txt.

To import a task list file, click Load tasks from file.

Manually creating a task list file

Sometimes it's convenient to manually create a list of nodes that need to be scanned.

Using the Load tasks from file command, you can turn such a list into tasks for the TSD scanner.

In general, the task file in TSD is a simple text file where each line is a command that adds one task.

The simplest example of a valid task file is a list of IP addresses and network names, each in a separate line. However, the options are not limited to network names and IP addresses. You can find the full list of supported notations here.


Scanning using agents

TSD sends an agent to a remote device to be able to scan it. The agent then studies the remote system, obtains inventory information in the form of a data file and sends it back to TSD. When the scanning is complete, the agent is erased from the remote system and no traces of scanning remain. You can learn more about the scanning technology from the White paper.

This section describes how TSD's scanner agents can be used as standalone tools.

  • Manual scan: use standalone scanner tools for inventorying assets locally when they're not accessible remotely.


Manual scan

Manual scan can be used to inventory assets that are not connected to your network or are inaccessible for regular scanning for one reason or another. For example, assets running Windows XP Home Edition can only be scanned this way due to OS limitations.

Manual scanning of any system involves three basic steps.

1. Copy the agent executable to the asset you need to scan

The agent (tniwinagent.exe) is located in TSD's installation folder (e.g. "C:\Program Files (x86)\Total Software Deployment").

2. Perform the scan

Launch the agent on the remote system. When the scanning is complete, a data file will be generated and, by default, placed into the directory the scanner is run from.

You can use these command line parameters for tniwinagent.exe:

  • /path:"\\server\share" allows to set a path to a folder where the data file will be placed;
  • /delay:XX specifies the gap in seconds between the agent's launch time and the start of the scan;
  • /overwrite overwrites the data file in case the target folder already contains its older version (otherwise, new files appended with (2), (3), etc. will be created after each scan).

Locate the generated data file and send it back to the system that runs your copy of TSD (or any other place TSD has access to).

3. Import the data into your Storage

You can do this in two ways: either by placing the file directly into the Storage folder or by using the Import menu.


Deployment desktop

The Deployment desktop is an area in TSD's main window between the Software storage and the Network storage when the Software deployment tab is selected. This is the key element of the program where Software deployment is set up and managed.

Main elements:

  1. Software deployment list;
  2. Deployment targets list;
  3. Section bar of the Deployment desktop;
  4. Mode switch bar;
  5. Current mode;
  6. Logs.

Topics:

  • Getting started
  • Assistant
  • Remote deployment
  • Deployment history
  • Logs


Getting started

Adding new tasks

The Deployment desktop works with the software and computers that are added to the Software deployment list and the Deployment targets list, respectively.

Software deployment list

You can Add to Software deployment list from the individual software context menus or select the software in the Software storage and drag & drop them into the Software deployment list.

It's possible to add software categories as well. Adding a category adds all programs belonging to it.

You can access the editor for a particular recorded method from the Deployment section in the Software deployment list. To do that, click its icon while holding Ctrl.

Deployment targets list

You can Add to Deployment targets list from the individual context menus of network devices or select the devices in the Network storage and drag & drop them into the Deployment targets list.

You can also add groups of devices. Drag & drop the root group to add all devices.

Managing deployment lists

Deployment lists can be saved, deleted or cleared.

Saving a list

  1. To be able to use a list in the future, save it by clicking either Save software list or Save computers list.
  2. Enter the title of the list and press Enter.
  3. To save the current list, simply click on the save button again.

To start a new list, select < New > from the drop-down list as shown on the screenshot below.

Deleting a list

To delete a list, select it from the drop-down list and click Remove software list or Remove computers list.

You can clear the software list or the computer list from the same toolbar or by right-clicking the empty area below the list and choosing Clear list.


Assistant

The Assistant allows to quickly determine which software has already been installed and on which computers, and if there might be any obsolete versions that you would like to update.

The Assistant is activated by a click on the corresponding tab. It combines two tools: one searches for computers to deploy to, and the other searches for software to deploy. Both are activated by clicking their tabs.

Find computers for deployment

In this mode, the Assistant will search for software from the Software deployment list on computers from the Network storage.

The search is performed based on the search string, which is taken from the software passport. The search string can be edited in the passport or right in the Assistant. Editing is enabled by a click on the string.

To initiate a search, simply click a button (Find computers). Expanding the node shows the latest search results from the current TSD session or, if there are none, launches a new search.

After editing and saving the search string, the helper will automatically do another search and display the results.

By default, the search string is filled with the contents of the Product name field in the installer's executable.

During a search for multiple software, the search is performed for each program in succession starting with the program that was added first.

The information about installed software is read from the computer inventory file located in the Network storage. The information can be updated by rescanning the computer and conducting a new search.

When the search is over, a brief result will be displayed above the search results for each program. It shows on how many computers the search string was found and on how many it was not found. Each of these two selections can be queued for deployment using the corresponding icons (Add found computer(s) to the deployment targets list and Add the rest of computers to the deployment targets list).

Below the line containing brief results, a report will be generated listing computers on which programs containing the search string were found. After comparing the software version in the Software storage with the version installed, you can add a computer to the Deployment targets list by clicking the corresponding icon, which can be found to the right of the node name.

If changes occurred in the Network storage, a warning will be displayed in the search results.

It's not possible to initiate a search if the Network storage is not opened.

Find software for deployment

In this mode, the Assistant will search for software from the Software storage on computers from the Deployment targets list.

As when searching for computers, the search string will be used, and it can be edited from the search results.

To initiate a search, simply click a button (Find software). Expanding the node shows the latest search results from the current TSD session or, if there are none, launches a new search.

During a search for multiple computers, the search is performed for each computer in succession starting with the one that was added first.

The information about installed software is read from the computer inventory file located in the Network storage. The information is updated by rescanning the computer.

When the computer inventory file is updated, the results will be automatically refreshed.

When the search is over, a brief result will be displayed above the search results for each computer. It shows for just how many programs the search string was found and on how many it wasn't. Each of these two selections can be queued for deployment using the corresponding icons (Add found software to the software deployment list and Add the rest of software to the software deployment list).

After comparing the software version in the Software storage with the version installed, you can add software to the Software deployment list by clicking the corresponding icon, which can be found in the results to the right of the software name.

If changes occurred in the Software storage, a warning will be displayed in the search results.

It's not possible to initiate a search if the Software storage is not opened.


Remote deployment

To switch to the Deployment mode, click the Deployment tab located on the section bar, under the deployment lists.

Deployment in TSD is a process of software installation to a remote computer without the remote user's input. The remote user will not be distracted by the deployment process.

Topics:

  • Preparing for deployment
  • The process and its results


Preparing for deployment

Preparing the Software deployment list

Select a deployment method for all software on your Software deployment list by clicking one of the method icons above the list, or select methods for each software individually.

Before deploying a program, you need to create at least one deployment package, as well as select program bitness in the Software editor.

A program without any deployment packages, or without any having been selected, will not be deployed.

Preparing the deployment targets list

When a device has been scanned successfully for the first time, the login that provided access becomes attached to it automatically. It's possible to switch to another login or create a new one from the Deployment targets list.

Logins are set in the same way as in the Scanner.

Readiness for deployment

The necessary conditions for deployment are as such:

  1. Software has been added to the Software deployment list.
  2. A computer or several have been added to the Deployment targets list.
  3. A deployment method is selected in the Software deployment list.

If one or several of the conditions have not been met, TSD will inform you accordingly.

The deployment tree and possible conflicts

One of the main elements of the Deployment desktop is the Deployment tree: an area consisting of a table structure, with rows representing computers from the Deployment targets list, while software from the Software deployment list is represented by columns. The cells of the table show the deployment status of each software for each computer.

By hovering over an icon in the Deployment tree cell, you'll be able to read a description of the alert or error in a hint. This information is also displayed in the Deployment log.

If TSD encounters a conflict, it will display a warning or an error.

Possible warnings:

  • If the Macro deployment package was created on a Windows version newer than Vista and the target computer operates on a version older than Windows Server 2003 (or vice versa), TSD will display a warning. For example, This macro was recorded on Windows 8 operating system. It may be incompatible with Windows Server 2003. This occurs because windows and controls may be displayed differently on different operating systems. In such cases, TSD may erroneously consider a window or control missing, which will prevent the service from interacting with them.
  • If the Sysshot deployment package was created on an OS with architecture different from the target computer's OS's, TSD will display a warning. For example, This sysshot was recorded on 64-bit operating system. It may be incompatible with 32-bit architecture. This occurs due to some differences in the registries of OS'es with different architectures.

Possible errors:

  • When attempting to deploy to a computer operating on Windows 2000 or older. For example, Silent install method is incompatible with Windows 2000.
  • When attempting to deploy a 64-bit application to a computer operating on a 32-bit OS. For example, This software is a 64-bit application. It is incompatible with Windows XP 32-bit.


The process and its results

To start the deployment process, press the Start deployment button.

Deployment

The progress of each task is displayed in the Status column.

The total progress is displayed in a separate progress bar.

To stop the deployment, click Cancel. TSD will not perform the remaining tasks in queue, but the current deployment process will finish.

To cease the current deployment process, click Halt. It may not cease immediately though.

It's not necessary to monitor the deployment process. You can switch to another mode while deployment is being performed in background. The icon of the Deployment section will display the progress.

When the deployment is being performed, such actions are prohibited: operations with the Storages (closing, reloading, removing software and computers), rerecording and editing the deployment packages engaged in the current deployment.

Deployment results

When the deployment is complete, you can see the result of each task in the main area.

If an error has occurred, the information about the error will be displayed in the Status column.

Back to editing closes the deployment results.

Deployment log

When preparing for deployment and during the deployment process, information about the software deployment status, possible errors and alerts will be displayed in the Deployment log.

The Hide log option allows the user to remove the log from view. There are options to remove selected entries from the log, as well as all the entries by using Clear.

The Deployment log filters (Information, Warnings, Errors, Success) allow the user to choose what kind of information to display.

More information about the event logs can be found in this section.


Deployment history

In the Software deployment history mode of the History section, the user has the ability to browse the deployment history by software from the Software deployment list.

To display detailed, step-by-step information about the deployment process, click + to the right of the title bar.

The displayed deployment history depends on which software is in the Software deployment list, therefore the entries in the history updates as software is added to or removed from the list.


Logs

Deployment desktop uses event logs. When the Deployment section is active, the Deployment log will be displayed. When using the other two sections, the Desktop log takes its place.

Logs can be hidden or visible. To change its display mode, press the corresponding button in its header, on the right side.

Another button in the log header allows to clear the log. Entries will be deleted without warning and cannot be restored after.

To delete a single log entry, click Delete to its right.

Log entries can be selected using your mouse's Rectangular selection or keyboard keys Shift and Ctrl and arrow keys, as well as using Select all from the context menu. To copy to clipboard, select Copy as text from the context menu or press Ctrl + C. The entries are copied to clipboard in the following format: "[Software display name | Computer name] message text".

The logs only store events within the current session.

Desktop log

The Desktop log predominantly displays messages about events and errors in the deployment lists, as well as Storage events.

The amount of messages can be seen in the log header.

Deployment log

When preparing for deployment and during the deployment process, information about the software deployment status, possible errors and alerts, as well as all the Desktop log entries, will be displayed in the Deployment log.

The Deployment log filters (Information, Warnings, Errors, Success) allow the user to choose what kind of information to display.

When the Deployment log is cleared, the Desktop log will be cleared as well.


Options

The Options are accessed by clicking the gear button in the top right corner of TSD's window.

General

This section covers storage settings, deployment and general program settings.

Deployment methods

Settings for recording and deploying Silent, Macro and Sysshot packages.

Scanner

Settings governing the scan behavior and the snapshot storing policy.

User manual

A link to a section of the User manual pertaining to the currently selected section in Options.

Find options

Before text is entered into the search field, contents of the selected section of Options are displayed. When the search is used, only the elements that contain the search query will be displayed. The search involves not only names of subsections and text of settings, but also various hints, and does not depend on which section is selected.


Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

Assistant list and description

class="pageTitle">

Assistant list and description